//---------------------------------------------------------------------------

#ifndef CFilterH
#define CFilterH
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
 #include "FFT3_class.h"

class CFILTER : public TThread
{
private:
        bool __fastcall read_file_1st(AnsiString file_in, bool close0 );
        double __fastcall sinc0(double x0);
        short __fastcall double2short(double x0);
        bool __fastcall trans0(int nth0);
        bool __fastcall trans2(int nth0);
        void __fastcall init0();
        void __fastcall final0();

               // WAVE@t@Cf[^
        char   file_head1[5];
        int    file_size_all;
        char   file_type[5];
        char   file_head2[5];
        char   file_head3[5];
        int    file_size_fmt;
        int    file_size_data;
        int    wave_size;
        int    freq0;           //sampling rate
        short    nblock;
        short    nchannel;
        int      navg;
        WAVEFORMATEX waveformatex;

        int  freq2;
        short nchannel2;

        // common file
        int file_handle;
        int file_handle2;
        
        #define DATABLOCK_SIZE       32768L
        
        int   size_data_buf2;
        short *data_buf;
        short *data_buf2;
        double *in0,*in1,*stock1;


        bool force_mono0;
        bool skip_sinc0;
        bool skip_lpf0;
        int  nstep_default0;
        int  nstep0;

        bool  use_FIR_LPF;
        float BAND_GENSUI_DB;
        float BANDWIDE_RATE;
        int   nfir0,ndelay0;


        // for sin table
        bool  use_SIN_TABLE;
        int   sin_table_size;
        double *sin_table;
        double delta_sin;

        //misc
        bool  one_flag0;

        // double speed or 4 times speed
        int double_speed0;
        bool double_table_use_flag0;
        double *double_table1, *double_table2, *double_table3;

        // fft overlap add
        bool fft_overlap_save_flag0;

       TFFT3_class   *FFT3_class0;

protected:
        void __fastcall Execute();
        void __fastcall ThreadDone(TObject * /*Sender*/);

public:
        __fastcall CFILTER(bool CreateSuspended);
        

        #define ONLY_READ1ST 1
        #define SRC_GO       2
        #define SRC_GO_WITH_FIR_FILES 3

        int  action_type;

        // for dual core
        int core_number;  // 1,2,3,4

        bool fir_lpf_test;
        float fs2_fs1_test;
};
//---------------------------------------------------------------------------
#endif
